<template>
  <div :class="componentClasses" data-testid="input-search" @click="focusInput">
    <sa-icon icon="search" />
    <input
      ref="input"
      v-model="currentValue"
      type="text"
      :placeholder="placeholder"
      :aria-labelledby="uniqueId"
      data-testid="input"
      @input="debouncedInput"
      @keypress.enter="$emit('search', currentValue)"
    />
    <div class="clear" data-testid="clear" @click="clearInput">
      <sa-icon icon="x" />
    </div>
  </div>
</template>

<script>
import { debounce } from 'lodash'

export default {
  name: 'SaInputSearch',
  props: {
    size: {
      type: String,
      default: 'regular'
    },
    placeholder: {
      type: String,
      default: 'Search'
    },
    // keyUp events are debounced by this amount (in milliseconds)
    timeout: {
      type: Number,
      default: 400
    },
    initialValue: {
      type: String,
      default: ''
    }
  },
  data(props) {
    return {
      currentValue: props.initialValue,
      debouncedInput: debounce(
        () => this.$emit('change', this.currentValue),
        this.timeout
      ),
      uniqueId: this.makeUniqueId()
    }
  },
  computed: {
    componentClasses() {
      const classes = ['input-search', 'input', this.size]
      if (this.currentValue !== '') {
        classes.push('active')
      }
      return classes
    }
  },
  methods: {
    focusInput() {
      this.$refs.input.focus()
    },
    clearInput() {
      this.currentValue = ''
      // fire immediately
      this.$emit('change', this.currentValue)
    }
  }
}
</script>

<style lang="scss" scoped>
.input-search {
  display: flex;
  flex-direction: row;
  width: min-content;
}
.icon {
  color: color(grey);
}
input {
  flex: 1 1 auto;
  min-width: 100px;
  width: 0;
  /* focus highlight is moved to container */
  &:focus {
    outline: 0;
  }
}
.clear .icon {
  color: transparent;
  transition: color 0.2s ease-out;
}

.active .clear {
  cursor: pointer;
  .icon {
    color: color(grey);
  }
}
</style>
